/* CSE142, 98 Autumn******************************************************
 * Homework 4
 * Student TUAN DUONG
 * ID 9810749
 * Section BF
 * tuandg@u.
 * Rain Gods and Goddesses************************************************/

#include "gp142.h"
#include <stdio.h>
#include <math.h>
#include <time.h>

#define FALSE   		         0
#define TRUE    		         1
#define HALFTRUE                 2

#define NUM_BUTTONS 	         8
#define BUTTON_HEIGHT  	        35
#define BUTTON_WIDTH 	        90

#define FONT_SIZE               12
#define TEXT_OFFSET       -XMAX+15   

#define SELECTED_COLOR       GREEN
#define	UNSELECTED_COLOR     BLACK 

#define ELEMENTS                 4           
#define MAX_PRECIP_EVENTS      500

#define XMAX            GP142_XMAX
#define YMAX            GP142_YMAX

#define FILL                     0
#define BLANK                    1

#define TOP_OF_DIRT (- 2 * (YMAX / 5))

#define MAX_PRECIP_TYPES         3
#define MAX_PRECIP_COLORS        3

#define X_COORD                  0
#define Y_COORD                  1
#define	TYPE                     2
#define COLOR                    3

#define NONE                     0
#define EVENT                    1
 
#define BUTTON                   1    
#define DIRT                     2
#define SKY                      3 

/*** use value of defined constant of colors in GP142.h***/   

#define RAIN                     1
#define SNOW                     2
#define HAIL                     3

#define RAINDROP_WIDTH           2

#define SNOWDROP_WIDTH           4
#define SNOWDROP_HEIGHT          5

#define HAILDROP_WIDTH           4
#define HAILDROP_HEIGHT          3

#define ICECUBE_WIDTH           10

#define SUN_X                   50
#define SUN_Y                   55

#define UFO_X                   50
#define UFO_Y                   30 

#define DESCENT                 10
#define ROLLING                  1
#define FALLING                  1  
#define FLYING                   8
#define RISING                   4
#define JUMP                    10
#define MAX_SPEED                8


/*******************  FUNCTION PROTOTYPES ********************************
**************************************************************************/

void DrawOpeningScreen();
void DrawClosingScreen();
void DrawOpeningText(int leftmost, int upmost, int font_zise);

void DrawButtons(int current_precip, int current_color);
void DrawLandscape(int sun_x, int sun_y, int UFO_x, int UFO_y, 
				                      int smoke_x, int smoke_y);

int  ClassifyMouseClick(int mouse_x, int mouse_y);
void HandleButton(int x, int y, int* current_precip, 
				  int* current_color, int* clear_weather);

void ClearAllPrecipitation(int precip[][MAX_PRECIP_EVENTS], int* numdrop, 
						   int* speed);
void DrawAllPrecipitation(int precip[][MAX_PRECIP_EVENTS], int numdrop);

void DrawRainDrop (int x, int y, int color);
void DrawSnowDrop (int x, int y, int color);
void DrawHailDrop (int x, int y, int color);
void DrawIceCube  (int x, int y, int color);

void LightUpTheWeather(int precip[][MAX_PRECIP_EVENTS], int* numdrop, 
					   int* speed);

void BadNewsMessage ();

/*************************************************************************
**************************************************************************/

int main(void){
  
     char key_hit;
	
	 int i,j = 0, 
		 speed = FALLING,
		 numdrop = 0,
		 event = NONE,
		 showbegin = HALFTRUE,      /*to control the stages*/
		 mouse_click = NONE;	 
	 
	 int quit = FALSE,
		 clear_weather = FALSE;
     
	 int mouse_x = 0,
		 mouse_y = 0;		 
		 
	 int precip[ELEMENTS][MAX_PRECIP_EVENTS];
		 
		 /*This 2D array 4 rows X 500 columns (max) is used to store four information 
		 about each drop, as weel as how many drops are being drawn*/
		 	 	 
	 int font_size = 0,
		 leftmost  = XMAX + 20, 
		 upmost    = -YMAX,
		 
		 smoke_x = XMAX/2+30,
		 smoke_y = TOP_OF_DIRT + 105,
  
	     sun_x = XMAX - SUN_X, 
	     sun_y = YMAX - SUN_Y,

		 UFO_x = -XMAX + UFO_X,
		 UFO_y =  YMAX - UFO_Y,
	          	   
	     current_precip = NONE,		
	     current_color = NONE;            

      time_t t; 
      srand (time(&t));	 /*random values returned by rand()*/      

      GP142_open();           
      GP142_logging(LOG_OFF);/*logging on displays GP142 Text window*/
      GP142_clear();	      
      GP142_animate(ANI_RUN);/*GP142_animate(ANI_HALT) stops animation*/
 
	  DrawOpeningScreen();
	  DrawOpeningText(leftmost, upmost, font_size);
     
	  /*initialization with a simple implementation*/        		

	  for(i = 0; i < ELEMENTS; ++i)
		  for ( j = 0;j < MAX_PRECIP_EVENTS; ++j)
	          precip[i][j] = 0 ;
 
	  while (!quit) { /*the main loop*/
			  
	/*possible returned values are GP142_QUIT, GP142_MOUSE and GP142_KBD*/
			 
		event = GP142_await_event(&mouse_x, &mouse_y, &key_hit);

			  switch (event) {
    
			  case GP142_QUIT:
    
				   quit = TRUE;      
				   break;
	     				 
			  case GP142_MOUSE:{
				  			   	  				   
				   mouse_click = ClassifyMouseClick(mouse_x, mouse_y);  
		
				   switch (mouse_click){ 

					   case BUTTON:{
								
					    	HandleButton(mouse_x, mouse_y, &current_precip, 
	   							            &current_color, &clear_weather);                    
						    							
							switch(clear_weather){
								
							case TRUE:
							
							    ClearAllPrecipitation(precip, &numdrop, &speed);
								break;

							case HALFTRUE:
								
								LightUpTheWeather(precip, &numdrop, &speed);
								break;
                            
							default:
								break;
							}
							
						}   
						    break;
						   
						case DIRT:
								
							break;

						case SKY:{  							
							
							if (current_precip != NONE && current_color != NONE) {
							
							/*Fill the array one column at a time accordingly 
							to the number of clicks.The variable numdrop indicates the 
							number of drops have been drawn up to date as well as the 
							column of the array have been filled. 
							Values of four elements:x, y coordinates, type 
							and color of a drop are in different row and assigned 
							and/or cleared at the same time.*/
								
								if (numdrop < MAX_PRECIP_EVENTS){
							
								precip [X_COORD][numdrop] = mouse_x;							
								precip [Y_COORD][numdrop] = mouse_y;
								precip [TYPE][numdrop] = current_precip;
   								precip [COLOR][numdrop] = current_color;
								
							/*prepare for the next click*/
                                
								numdrop++;
								
								}
							else								
								showbegin = FALSE;								
							}	  			 
						}							
							break;

                        default:							
							
							break;

				   } /* end switch*/
				}

				  break;		
		      		  			  
			  case GP142_PERIODIC:{    
      					  
				  /***for decoration purpose only ***/
				  /*these variables gets periodically updated
                  and assigned new value, others are randomly so*/ 

				  if(leftmost > TEXT_OFFSET + 50) 
					  
					  leftmost -= 15;
				  
				  if(upmost <= 3*(YMAX/4))
					  
					  upmost += 20;
				  
				  if(font_size < 2*FONT_SIZE)
					  
					  font_size ++;
				  
				  smoke_y += RISING;
				  smoke_x += rand() % 7 - 3;      
				  
				  if (smoke_y - YMAX >= 200 && rand () % 50 == 0){
				  					  
					  smoke_y = TOP_OF_DIRT + 105;
					  smoke_x = XMAX / 2 +30;
				  }
			                             				  
				  sun_x -= ROLLING;
				  
				  if (sun_x < -XMAX - 25) {

					  sun_x = -sun_x;
					  sun_y -= DESCENT;

				  }
				  				  
				  UFO_x += FLYING;		      			                		    
				  UFO_y += rand () % 20 - 10;		  		  			  			  		  
				  
				  if ( UFO_x > XMAX + 10 && rand () % 30 == 0)

					  UFO_x = - UFO_x;

				  if ( UFO_y > YMAX || UFO_y < YMAX/2)

					  UFO_y = rand () % (3 * YMAX)/4 ;
				  
				  /************end decoration**************/
				  
				  /**********Now with the show************/			  
				  				  
				  /*randomly increase speed*/
				  
				  if ( speed < MAX_SPEED && rand()% 1000 == 0)
				 
                  speed ++; 

				  /*the loop below ends at the last row of the portion 
				  of the array that has been filled which carrying 
				  the index of (numdrop - 1)*/
				  
				  for ( i = 0; i < numdrop; i++){
					  
					  switch (precip [TYPE][i]){
					  
					  case RAIN:
                      
						  precip [Y_COORD][i] -= 3*speed;
						  break;
					  
					  case HAIL:
                           
						  precip [Y_COORD][i] -= 2*speed;
						  break;
					  
					  case SNOW:
                          
						  precip [Y_COORD][i] -= speed;
					      break;
                      
					  default:
						  break;
					  }       
					 			    			    
					   precip [X_COORD][i] += rand () % 3 - 1; 				  
				  
				      /**the drop is waving while falling**/				  
					  
					  if ((precip[Y_COORD][i]) <= (TOP_OF_DIRT - 20)){						   
                      
					/*"Reincarnation"!!but continuity is the proper term*/
						  
						  precip[Y_COORD][i] = YMAX;
				          
					   /*Reduplication to maintain the continuity of the 
					precipitation and ensure that there will be some growth*/									 
						  
						  if ((rand()% 2 == 0) && (numdrop < MAX_PRECIP_EVENTS)){
							  
					 /*when a drop disappears the odd of having two drops of 
					  the same type and color vs one are 50/50*/

					 /*numdrop is the index of the column that is not yet filled*/
						      
							 precip [X_COORD][numdrop] = precip[X_COORD][i]; 							
						     precip [Y_COORD][numdrop] = precip[Y_COORD][i] 
								                          + rand()%30 + 30;
						     precip [TYPE][numdrop] = precip[TYPE][i];
   						     precip [COLOR][numdrop] = precip[COLOR][i];
							 							 							 
							 /*update the index*/
							 
      						 numdrop++;					
						  
						  } /*end of conditional of reduplication*/
					  
					  } /*end conditional of re-appearances*/
				  
				  }  /* for loop end */ 
				             
			 } /*end case GP142_PERIODIC */ 

		      break;
		
          default:

              break;		
		
		}/*end switch here*/
        		
		   if ( event == GP142_MOUSE  && mouse_y > -FONT_SIZE / 2 
			   && mouse_x < FONT_SIZE/2 && mouse_x < -XMAX/3 
			   && mouse_x > -2*XMAX/3)
			         
			   showbegin = TRUE;
		      
		   if ( showbegin == HALFTRUE ){
		
		     DrawOpeningScreen(); 
			 DrawOpeningText(leftmost, upmost, font_size);
						
			}
			
		   else if (showbegin == TRUE){ 	        				  
		   
		     DrawLandscape(sun_x, sun_y, UFO_x, UFO_y, smoke_x, smoke_y);
             DrawButtons(current_precip, current_color);    
		     DrawAllPrecipitation(precip, numdrop);
			 GP142_printfXY(RED, XMAX-50,-YMAX+20, 24, "%d", numdrop);
			 
			 /*this is to spy the number of drops as a debuging tools*/
			 			
		   } 
		   		    
		   if( showbegin == FALSE)  
			  DrawClosingScreen();		    	   
				
	   }/* main event loop ends here*/   
	   
	   GP142_close();	 
 	
       return 0;

}/*end of main*/ 

/*************************************************************************
                         FUNCTIONS
**************************************************************************/

void ClearAllPrecipitation (int precip[ELEMENTS][MAX_PRECIP_EVENTS], 
							int* numdrop, int* speed){
 	int i, j;
	
	for (i = 0; i < ELEMENTS; ++i)
		for (j = 0 ; j < *numdrop ; ++j)
	        
			precip[i][j] = NONE;
		
		/*Start over!!!!*/    
		
		*numdrop = 0;
		*speed = FALLING;
 
}
/*************************************************************************
**************************************************************************/

void LightUpTheWeather(int precip[ELEMENTS][MAX_PRECIP_EVENTS], 
					    int* numdrop, int* speed){
	
	int i, j, randNum;

	if ( *numdrop != 0){ /*avoid divided by zero*/	
	
		randNum = rand() % *numdrop;
	
	/*randNum gets anynumber from 0 to (numdrop - 1)*/

	for ( i = 0; i < ELEMENTS; ++i)
        for (j = randNum ; j < *numdrop; ++j)
		   
			precip[i][j] = NONE;		
		   
		*numdrop = randNum;/* set up the array after the partial cleanup*/ 
    	*speed = FALLING;  /*slow down!!!!*/

	}	
}
/*************************************************************************
/*************************************************************************/

void DrawRainDrop (int rain_x, int rain_y, int rain_color) { 

    GP142_circleXY (rain_color, rain_x, rain_y, RAINDROP_WIDTH);
	GP142_triangleXY(rain_color, rain_x - RAINDROP_WIDTH, rain_y, rain_x + 
		             RAINDROP_WIDTH, rain_y, rain_x, 
					 rain_y + 3*RAINDROP_WIDTH, FILL);

}

/*************************************************************************
/*************************************************************************/

void DrawSnowDrop (int snow_x, int snow_y, int snow_color) {

   	GP142_triangleXY (snow_color, snow_x, snow_y, snow_x + SNOWDROP_WIDTH,
		              snow_y, snow_x, snow_y + SNOWDROP_HEIGHT, FILL);

}

/*************************************************************************
**************************************************************************/

void DrawHailDrop (int hail_x, int hail_y, int hail_color) { 

    GP142_rectangleXY (hail_color, hail_x, hail_y, hail_x + HAILDROP_WIDTH, 
	                 hail_y + HAILDROP_HEIGHT, FILL);	

}

/*************************************************************************
**************************************************************************/

void DrawAllPrecipitation(int precip[ELEMENTS][MAX_PRECIP_EVENTS], 
						  int numdrop){
	int i;
	
	for ( i = 0; i < numdrop; i++){
			
	  if ( precip[Y_COORD][i] > TOP_OF_DIRT - 20 ){      

			switch (precip[TYPE][i]) {

		    case RAIN:
				                 
				DrawRainDrop (precip[X_COORD][i], precip[Y_COORD][i],
					          precip[COLOR][i]);
				break;

			case SNOW:
                
				DrawSnowDrop (precip[X_COORD][i], precip[Y_COORD][i], 
					          precip[COLOR][i]);
				break;
       
			case HAIL:
                
				DrawHailDrop (precip[X_COORD][i], precip[Y_COORD][i], 
					          precip[COLOR][i]);
				break;
		
			default:

				break;
		}			
	  }
	}
}
	
/*************************************************************************
**************************************************************************/

int  ClassifyMouseClick(int mouse_x, int mouse_y){

  	if ((mouse_x < -XMAX + BUTTON_WIDTH) && (mouse_y < YMAX) 
         &&(mouse_y > (YMAX - NUM_BUTTONS * BUTTON_HEIGHT)))
    
		return BUTTON;
    
	else if (mouse_y <= TOP_OF_DIRT)
		
    	    return DIRT;
	
	     else
			
		   	return SKY;
}       

/*************************************************************************
**************************************************************************/

void DrawOpeningScreen (){

	GP142_rectangleXY (BLACK, -XMAX, -YMAX, XMAX, YMAX, FILL); 
}

/**************************************************************************
***************************************************************************/

void DrawOpeningText (int leftmost, int upmost, int font_size){
	
	GP142_printfXY(MED_GRAY, TEXT_OFFSET + 54, upmost - 4, 3*FONT_SIZE, 
		           "Welcome to RainGoddess,\nThunderGod,\nand LandscapeEvil.");
	GP142_printfXY(MED_GRAY, TEXT_OFFSET + 52, upmost - 2, 3*FONT_SIZE, 
		           "Welcome to RainGoddess,\nThunderGod,\nand LandscapeEvil.");
	GP142_printfXY(WHITE, TEXT_OFFSET +50, upmost, 3*FONT_SIZE, 
		           "Welcome to RainGoddess,\nThunderGod,\nand LandscapeEvil.");
    
	GP142_printfXY(BROWN, TEXT_OFFSET + 53, -2*(YMAX/3) - 3, font_size,
		           "Written by Tuan Duong\nStudend ID %d", 9810725+font_size); 	
	GP142_printfXY(BROWN, TEXT_OFFSET + 52, -2*(YMAX/3) - 2, font_size,
		           "Written by Tuan Duong\nStudend ID %d", 9810725+font_size); 
	GP142_printfXY(GOLD, TEXT_OFFSET + 50, -2*(YMAX/3),  font_size,
		           "Written by Tuan Duong\nStudend ID %d", 9810725+font_size); 
	
	GP142_printfXY(SEA_GREEN, leftmost+2, -2, 2*FONT_SIZE,"Click here to start!!");	
	GP142_printfXY(SEA_GREEN, leftmost+1, -1, 2*FONT_SIZE,"Click here to start!!");
    GP142_printfXY(TURQUOISE, leftmost, 0, 2*FONT_SIZE,"Click here to start!!");

}

/*************************************************************************
**************************************************************************/

void DrawLandscape(int sun_x, int sun_y, int UFO_x, int UFO_y, 
				   int smoke_x, int smoke_y){

int jump, X, Y;

   /*Numbers for use explicitly at one or two drawings are not defined 
    constant*/ 

   /*draw the background*/
   GP142_rectangleXY(ICE_BLUE, -XMAX, -YMAX, XMAX, YMAX, FILL);
  
   /*draw the thunder effect*/
   GP142_rectangleXY(WHITE, -XMAX, -YMAX, XMAX, YMAX, rand()%2);
  
   /*draw the sun*/ 
   GP142_circleXY(YELLOW, sun_x, sun_y , 50);
  
   /*and it is a friendly one*/
   if ( abs(UFO_x - sun_x) <= 30){
  
   GP142_circleXY(BLACK , (sun_x - 20), (sun_y + 20), 3);
   GP142_circleXY(BLACK , (sun_x + 20), (sun_y + 20), 3);
   GP142_ovalXY(RED, sun_x - 8, sun_y - 25, sun_x + 8, sun_y - 25, 
	            rand ()%20);
 
  }

   /*draw the unidentified flying object randomly using possible 24 colors*/   
   GP142_ovalXY (rand()%24, UFO_x, UFO_y, UFO_x + rand ()%12 , UFO_y, 
	             rand ()%12 );

  
   /*draw the lanscape*/
   GP142_rectangleXY(BLACK, -XMAX, -YMAX, XMAX, TOP_OF_DIRT, FILL);
  
   GP142_printfXY (BLUE, TEXT_OFFSET, -YMAX+30, FONT_SIZE + 2,
           "Click a weather type and a color, then click on the picture.");
   GP142_triangleXY(MED_GRAY,  -XMAX, TOP_OF_DIRT, XMAX, 
                  TOP_OF_DIRT, 0, 4 * (YMAX/5) , FILL);
   GP142_triangleXY(OLIVE, - 5 *(XMAX/4), TOP_OF_DIRT, XMAX/3, 
	               TOP_OF_DIRT,-3 * (XMAX/4), 2 * (YMAX/3) , FILL);
   GP142_triangleXY(FOREST_GREEN, -XMAX/3 , TOP_OF_DIRT,
                   XMAX, TOP_OF_DIRT, XMAX, 2 * (YMAX/3), FILL);
  
   /*draw a tree*/
   GP142_triangleXY(BROWN, -XMAX/3 - 20 , TOP_OF_DIRT - 80, -XMAX/3+40 , 
	                TOP_OF_DIRT - 80,-XMAX/3 + 10  , TOP_OF_DIRT + 70, FILL);
   GP142_rectangleXY(BROWN,  -XMAX/3 - 10 , TOP_OF_DIRT - 50, -XMAX/3+ 30, 
	                 TOP_OF_DIRT +100, FILL);
   GP142_circleXY(SEA_GREEN, -XMAX/3 + 10 , TOP_OF_DIRT + 100, 70);
   GP142_circleXY(SEA_GREEN, -XMAX/3 - 80 , TOP_OF_DIRT + 55, 30);
   GP142_circleXY(SEA_GREEN, -XMAX/3 - 40 , TOP_OF_DIRT + 75, 50);
   GP142_circleXY(SEA_GREEN, -XMAX/3 + 60 , TOP_OF_DIRT + 75, 50);
   GP142_circleXY(SEA_GREEN, -XMAX/3 + 100, TOP_OF_DIRT + 55, 30);

   /*this is for the animated smoke from the chimney*/
   GP142_circleXY(LT_GRAY, smoke_x, smoke_y, rand () % 4 + 5);
   GP142_circleXY(LT_GRAY, smoke_x, smoke_y + 10, rand () % 4 + 10);
   GP142_circleXY(LT_GRAY, smoke_x, smoke_y + 25, rand () % 6 + 13);
   GP142_circleXY(LT_GRAY, smoke_x, smoke_y + 45, rand () % 8 + 17);
   GP142_circleXY(LT_GRAY, smoke_x, smoke_y + 70, rand () % 10 + 20);
  
   /*a house can be animated sometimes*/
   jump = 0;
   if ( rand () % 30 == 0)
	  jump = JUMP;	    
   
   /*draw a house, and make it jump when it should (;-P) */
   GP142_rectangleXY(ORANGE, XMAX/2+20, TOP_OF_DIRT + 70 + jump, XMAX/2+40, 
	                 TOP_OF_DIRT+105+jump, FILL); 
   GP142_triangleXY(RED, XMAX/3 - 20, TOP_OF_DIRT + 50 +jump, XMAX/3 + 125, 
	       TOP_OF_DIRT + 50+jump, XMAX/2 + 5, TOP_OF_DIRT + 100+jump, FILL);	  
   GP142_rectangleXY(YELLOW, XMAX/3, TOP_OF_DIRT - 20+jump, XMAX/3 + 105, 
	                 TOP_OF_DIRT + 50+jump, FILL);     
   GP142_rectangleXY(BLACK, XMAX/3 + 10, TOP_OF_DIRT - 20 + jump, XMAX/3 + 40,
	                  TOP_OF_DIRT + 30 + jump, BLANK);
   GP142_rectangleXY(TURQUOISE, XMAX/3 + 11, TOP_OF_DIRT - 19 + jump, 
	                 XMAX/3 + 39, TOP_OF_DIRT + 29 + jump, FILL);
   GP142_circleXY(BLACK, XMAX/3 + 12, TOP_OF_DIRT + 5+jump, 2);
  

   /*white blinds behind of the window*/
   GP142_rectangleXY(WHITE, XMAX/2 + 1, TOP_OF_DIRT + 1+jump, XMAX/2 + 44, 
	                 TOP_OF_DIRT + 44+jump, FILL);
  
   /*loop and modularity come together in designing checkered windows*/
   for ( X = 0; X < 45; X += 15)
	  for(Y = 0; Y < 45; Y += 15)
         GP142_rectangleXY(BLACK, XMAX/2 + X, TOP_OF_DIRT + Y + jump, 
		                XMAX/2 + 15 + X,TOP_OF_DIRT + 15 + Y+ jump, BLANK);  
}

/*************************************************************************
************ Figure out which button was clicked**************************/

void HandleButton(int x, int y, int *current_precip, 
				  int *current_color, int *clear_weather){
  
   int buttonNum = 0;

   *clear_weather = FALSE; 
  
   /*locate the rectangle which is mouseclicked*/

   buttonNum = (YMAX - y)/BUTTON_HEIGHT;
   
   if (buttonNum < MAX_PRECIP_TYPES ){
  
	  switch(buttonNum) {
  
      case 0:
    
	    *current_precip = RAIN;    
		break;
  
	  case 1:
    
		*current_precip = SNOW;    
		break;

	  case 2:
   
		*current_precip = HAIL;    
		break;
  
      default:
        
        *current_precip = NONE;
        break;
	  }

   } /*no <else> here, cuz clicking on type buttons doesn't exclude clicking 
       on color ones*/
  
   if (buttonNum >= MAX_PRECIP_TYPES && buttonNum < MAX_PRECIP_TYPES + 
	               MAX_PRECIP_COLORS){

      switch (buttonNum){
        
	  case 3:
    
		*current_color = WHITE;    
	     break;
  
      case 4:
    
	    *current_color = BLUE;    
	     break;
  
      case 5:
    
	    *current_color = YELLOW;    
	     break;

	  default:
        
	    *current_color = NONE;
		break;
	  
	  }
  }

   if (buttonNum ==6)    
			
		*clear_weather = HALFTRUE;		  
	
   if(buttonNum == 7)
	     
    	*clear_weather = TRUE;    	  
}

/****************** Draws the buttons ************************************
**************************************************************************/

void DrawButtons(int current_precip, int current_color){

    int i;

    for(i = 0; i < NUM_BUTTONS; i++) {

      GP142_rectangleXY(LT_GRAY,-XMAX + 4, YMAX - i * BUTTON_HEIGHT - 2,
              -XMAX + BUTTON_WIDTH, YMAX - (i + 1)*BUTTON_HEIGHT - 2, FILL);
	  GP142_rectangleXY(BLACK,-XMAX + 4, YMAX - i * BUTTON_HEIGHT - 2,
              -XMAX + BUTTON_WIDTH, YMAX - (i + 1)*BUTTON_HEIGHT - 2, BLANK);
  }

    i = YMAX - 25;
    if (current_precip == RAIN)
      GP142_printfXY(SELECTED_COLOR, TEXT_OFFSET, i, FONT_SIZE, "Rain");	
    else
      GP142_printfXY(UNSELECTED_COLOR, TEXT_OFFSET, i, FONT_SIZE, "Rain");	 
    i -= BUTTON_HEIGHT;
    if (current_precip == SNOW)
      GP142_printfXY(SELECTED_COLOR, TEXT_OFFSET, i, FONT_SIZE, "Snow");
    else
      GP142_printfXY(UNSELECTED_COLOR, TEXT_OFFSET, i, FONT_SIZE, "Snow");   
    i -= BUTTON_HEIGHT;
    if (current_precip == HAIL)
      GP142_printfXY(SELECTED_COLOR, TEXT_OFFSET, i, FONT_SIZE, "Hail");	
    else
      GP142_printfXY(UNSELECTED_COLOR, TEXT_OFFSET, i, FONT_SIZE, "Hail");	
    i -= BUTTON_HEIGHT;  
    if (current_color == WHITE)
      GP142_printfXY(SELECTED_COLOR, TEXT_OFFSET, i, FONT_SIZE, "White");	
    else
      GP142_printfXY(UNSELECTED_COLOR, TEXT_OFFSET, i, FONT_SIZE, "White");  
    i -= BUTTON_HEIGHT;
    if (current_color == BLUE)
      GP142_printfXY(SELECTED_COLOR, TEXT_OFFSET, i, FONT_SIZE, "Blue");
    else
      GP142_printfXY(UNSELECTED_COLOR, TEXT_OFFSET, i, FONT_SIZE, "Blue");    
    i -= BUTTON_HEIGHT;  
    if (current_color == YELLOW)
      GP142_printfXY(SELECTED_COLOR, TEXT_OFFSET, i, FONT_SIZE, "Yellow");	
    else
      GP142_printfXY(UNSELECTED_COLOR, TEXT_OFFSET, i, FONT_SIZE, "Yellow");    
    i -= BUTTON_HEIGHT;

	/*these two buttons won't change their colors*/
  
   GP142_printfXY(BLACK, TEXT_OFFSET, i, FONT_SIZE, "Lighten Up");  
   i -= BUTTON_HEIGHT;	   
   GP142_printfXY(BLACK, TEXT_OFFSET, i, FONT_SIZE, "Cease!");

}

/************************************************************************
*************************************************************************/

void BadNewsMessage (void) {

	GP142_printfXY (RED, -200+4, -4, 32, "BAAAADDD NEWS!!!!!!!!!");
	GP142_printfXY (RED, -200+3, -3, 32, "BAAAADDD NEWS!!!!!!!!!");
	GP142_printfXY (RED, -200+2, -2, 32, "BAAAADDD NEWS!!!!!!!!!");
	GP142_printfXY (RED, -200+1, -1, 32, "BAAAADDD NEWS!!!!!!!!!");
	GP142_printfXY (RED, -200, 0, 32, "BAAAADDD NEWS!!!!!!!!!");
	GP142_printfXY (RED, -100 +4, -54,32, "FLOOOOOOOD!!!!!!!!!");
    GP142_printfXY (RED, -100 +3, -53,32, "FLOOOOOOOD!!!!!!!!!");
    GP142_printfXY (RED, -100 +2, -52,32, "FLOOOOOOOD!!!!!!!!!");
    GP142_printfXY (RED, -100, -50, 32, "FLOOOOOOOD!!!!!!!!!");

}

/************************************************************************
*************************************************************************/

void DrawClosingScreen() {

	GP142_rectangleXY(BLACK, -XMAX, -YMAX, XMAX, YMAX, FILL);
	BadNewsMessage();

}

/***********************************************************************
*************************************************************************
Comment

1)It's common to intialize variables with 0s. 
In this case 3 elements can be known after initialization.Colors are BLACK, 
positions (or coordinations) are at the origin, only the types are unknown. 
During the process I encounted the drawing of a set of black drops with 
various shape coming out from the center of the GP142 windows. Weird!!!  

2)I didn't design the program to draw the drops when the number of drop has 
exceeded the defined constant for the array column as the sample does. 
However my strategy is to set up a condition to check when the click
overflows the array capicity set the variable numdrop back to zero and then
start to overwite the array column by column while leaving the rest untouched 
until the next click calls. The drops whose data stored in that column will 
dissapear, but a new drop will show up. I costruct my code so that when the 
user click when the array has been full,the program exits.  
  
2)The final test was done with MAX_PRECIP_EVENTS set to 500. If I just maintain 
continuity, but ignore the growth (i.e increase the number of drops without 
clicking, the program works fine. When I construct the code so that the number
of drop goes up overtime and the falling rate increase, the program display 
sluggish motions. My suspicion is that the computer was saturated with too 
many for loops and animation. The debugging windows also automatically shows 
strange values of array subcripts when the program cause memory faults. 

3)I tried to use debug to track the value of numdrop, but the compiler turned
to the debugging windows before a new drop was added automatically. So I wrote 
a code that display the number of drop on the far right bottom corner of the window.
  
5)The ideas of an introduction sequence was from Alexander Dioso in his 
Pizza Factory homework. I did, however, construct my code differently.

***************************************************************************
***************************************************************************/




